Home / Common Vulnerability Exposure BE-2021-0003

BE-2021-0003: Out-of-bounds and use-after-free vulnerabilities in MicroStation and MicroStation-based applications

Bentley ID: BE-2021-0003
CVE ID: CVE-2021-34873, CVE-2021-34887, CVE-2021-46599, CVE-2021-46609, CVE-2021-46612, CVE-2021-46619, CVE-2021-46633
Severity: 7.8 (High)
CVSS v3.1:  AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H
Publication date: 7th December 2021
Revision date: 7th December 2021

Summary

MicroStation and MicroStation-based applications may be affected by out-of-bounds or use-after-free vulnerabilities when opening maliciously crafted PDF files. Exploiting these vulnerabilities could lead to code execution.

Details

The following vulnerabilities related to this advisory were discovered by TrendMicro ZDI: ZDI-CAN-14696, ZDI-CAN-14840, ZDI-CAN-15393, ZDI-CAN-15403, ZDI-CAN-15406, ZDI-CAN-15413, ZDI-CAN-15463.

Using an affected version of MicroStation or MicroStation-based application to open a PDF file containing maliciously crafted data can trigger an out-of-bounds or use-after-free vulnerability. Exploitation of these vulnerabilities within the parsing of PDF files could enable an attacker to execute arbitrary code in the context of the current process. 

Affected Versions

ApplicationsAffected VersionsMitigated Versions
MicroStationVersions prior to 10.16.02.*10.16.02.* and more recent
Bentley ViewVersions prior to 10.16.02.*10.16.02.* and more recent

Recommended Mitigations

Bentley recommends updating to the latest versions of MicroStation and MicroStation-based applications. As a general best practice, it is also recommended to only open PDF files coming from trusted sources.

Acknowledgment

Thanks to Francis Provencher {PRL} for discovering ZDI-CAN-14696
Thanks to Mat Powell of Trend Micro Zero Day Initiative for discovering the rest of the vulnerabilities related to this advisory

Revision History

DateDescription
7th December 2021First version of the advisory
4th February 2022Adding new CVE numbers provided by ZDI